import pyglet


class Piece:
    def __init__(self, color, type, x, y):
        # Ask the type of the piece
        self.type = type
        self.cell = [x, y]
        self.position = [x, y]   # y = letter es. 'A'
        self.position = self.grid_to_pos()
        print(self.position)
        self.color = color

        # Selection Logic
        self.isSelected = False
        image = pyglet.image.load('C:/Users/aless/Documents/Python/2D_games/Chess/resources/selected.png')
        self.selected_sprite = pyglet.sprite.Sprite(image, x=self.position[0], y=self.position[1])

        # Create Sprite
        image = load_image(self.color, self.type)
        self.sprite = pyglet.sprite.Sprite(image, x=self.position[0], y=self.position[1])

    def draw(self):
        self.sprite.draw()
        if self.isSelected is True:
            self.selected_sprite.draw()

    def update(self):
        debug = False
        # Update position
        if debug is True:
            print('Update: ' + str(self.position))
        self.cell = self.pos_to_grid()
        self.position = self.grid_to_pos()

        # Set positions
        self.sprite.x = self.position[0]
        self.sprite.y = self.position[1]

        if self.isSelected is True:
            self.selected_sprite.x = self.position[0]
            self.selected_sprite.x = self.position[1]

    # Return a position [cell_x, cell_y] = es[5, 8]
    def pos_to_grid(self):
        debug = False
        cell = []
        if debug is True:
            print('-Initial value' + str(self.position))

        # x axis
        if self.position[0] == 400:
            self.cell[0] = 8
        elif self.position[0] == 350:
            self.cell[0] = 7
        elif self.position[0] == 300:
            self.cell[0] = 6
        elif self.position[0] == 250:
            self.cell[0] = 5
        elif self.position[0] == 200:
            self.cell[0] = 4
        elif self.position[0] == 150:
            self.cell[0] = 3
        elif self.position[0] == 100:
            self.cell[0] = 2
        elif self.position[0] == 50:
            self.cell[0] = 1

        # y axis
        if self.position[1] == 400:
            self.cell[1] = 8
        elif self.position[1] == 350:
            self.cell[1] = 7
        elif self.position[1] == 300:
            self.cell[1] = 6
        elif self.position[0] == 250:
            self.cell[1] = 5
        elif self.position[1] == 200:
            self.cell[1] = 4
        elif self.position[1] == 150:
            self.cell[1] = 3
        elif self.position[1] == 100:
            self.cell[1] = 2
        elif self.position[1] == 50:
            self.cell[1] = 1

        if debug is True:
            print('-Final value:' + str(self.cell))
        return self.cell

    # Get relative position
    def grid_to_pos(self):
        # position = [x, y]

        # 'x' axis
        if self.cell[0] == 1:
            self.position[0] = 50
        elif self.cell[0] == 2:
            self.position[0] = 100
        elif self.cell[0] == 3:
            self.position[0] = 150
        elif self.cell[0] == 4:
            self.position[0] = 200
        elif self.cell[0] == 5:
            self.position[0] = 250
        elif self.cell[0] == 6:
            self.position[0] = 300
        elif self.cell[0] == 7:
            self.position[0] = 350
        elif self.cell[0] == 8:
            self.position[0] = 400

        # 'y' axis
        if self.cell[1] == 1:
            self.position[1] = 400
        elif self.cell[1] == 2:
            self.position[1] = 350
        elif self.cell[1] == 3:
            self.position[1] = 300
        elif self.cell[1] == 4:
            self.position[1] = 250
        elif self.cell[1] == 5:
            self.position[1] = 200
        elif self.cell[1] == 6:
            self.position[1] = 150
        elif self.cell[1] == 7:
            self.position[1] = 100
        elif self.cell[1] == 8:
            self.position[1] = 50

        return self.position


# Function that return the right image for the type and color
def load_image(color, type):
    image: pyglet.image

    # White
    if color is 'W':
        if type is 'Bishop':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/white_bishop.png")
            return image
        elif type is 'Horse':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/white_horse.png")
        elif type is 'Pawn':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/white_pawn.png")
        elif type is 'King':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/white_king.png")
        elif type is 'Queen':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/white_queen.png")
        elif type is 'Tower':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/white_tower.png")
        else:
            print("Wrong type")

    # Black
    elif color is 'B':
        if type is 'Bishop':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/black_bishop.png")
            return image
        elif type is 'Horse':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/black_horse.png")
        elif type is 'Pawn':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/black_pawn.png")
        elif type is 'King':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/black_king.png")
        elif type is 'Queen':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/black_queen.png")
        elif type is 'Tower':
            image = pyglet.image.load("C:/Users/aless/Documents/Python/2D_games/Chess/resources/black_tower.png")
        else:
            print("Wrong type")

    # Error Check
    else:
        print("Wrong color")

    return image
